/*
 * Copyright (C) 2010 Xisco Faulí Tarazona
 *
 * This file is part of Domestica.
 * 
 * Domestica is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * Domestica is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domestica; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

package beans;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.ArrayList;

import objects.Image;
import objects.Location;
import objects.StateImage;
import objects.SubLocation;
import objects.LocationDevice;

import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

public class LocationsPage {

	private Location currentLocation;
	private Collection<SubLocation> subLocations;
	private Collection<Image> locationDevices;
	private Boolean pageRendered;

	private Map currentStateMap;
	private Collection locationCol;

	public void getImages(String currentItem) {

		Map session = FacesContext.getCurrentInstance().getExternalContext()
				.getSessionMap();
		if (currentStateMap == null) {
			currentStateMap = (Map<String, StateImage>) session
					.get("currentStateMap");
		}
		if (locationCol == null) {
			locationCol = (Collection) session.get("locations");
		}

		if (locationDevices == null) {
			locationDevices = new ArrayList<Image>();
		} else {
			locationDevices.clear();
		}
		if (subLocations == null) {
			subLocations = new ArrayList<SubLocation>();
		} else {
			subLocations.clear();
		}

		pageRendered = true;

		Iterator iLocation = locationCol.iterator();
		while (iLocation.hasNext()) {
			Location l = (Location) iLocation.next();
			if (currentItem.equals(l.getId())) {
				currentLocation = l;
				if (!l.getSubLocation().isEmpty()) {
					Iterator i = l.getSubLocation().iterator();
					while (i.hasNext()) {
						SubLocation s = (SubLocation) i.next();
						subLocations.add(s);
					}
				}
				if (!l.getLocationDevice().isEmpty()) {

					Iterator i = l.getLocationDevice().iterator();
					while (i.hasNext()) {
						LocationDevice s = (LocationDevice) i.next();
						try {
							StateImage currentState = (StateImage) currentStateMap
									.get(s.getDeviceIDRef());

							Image auxImage = new Image();
							auxImage.setUrl(currentState.getImageFile());
							auxImage.setPosX(s.getImagePosition().getPosX());
							auxImage.setPosY(s.getImagePosition().getPosY());
							auxImage
									.setHeight(s.getImagePosition().getHeight());
							auxImage.setWidth(s.getImagePosition().getWidth());
							auxImage.setId(s.getDeviceIDRef());
							locationDevices.add(auxImage);
						} catch (Exception e) {
						}
					}
				}

			}
		}
		FacesContext context = FacesContext.getCurrentInstance();

		Tree tree = (Tree) context.getApplication().getExpressionFactory()
				.createValueExpression(context.getELContext(), "#{TreeBean}",
						Tree.class).getValue(context.getELContext());

		tree.setSelectedNode(currentLocation.getId());

		Iterator i = subLocations.iterator();
		while (i.hasNext()) {
			SubLocation s = (SubLocation) i.next();
			Collection<Image> thumbnails = new ArrayList<Image>();
			Iterator iter = locationCol.iterator();
			while (iter.hasNext()) {
				Location l = (Location) iter.next();
				if (l.getId().equals(s.getLocationIDRef())) {
					if (!l.getLocationDevice().isEmpty()) {
						Iterator iterator = l.getLocationDevice().iterator();
						while (iterator.hasNext()) {
							LocationDevice loc = (LocationDevice) iterator
									.next();
							try {
								StateImage currentState = (StateImage) currentStateMap
										.get(loc.getDeviceIDRef());
								Image auxImage = new Image();
								auxImage
										.setUrl(currentState.getThumbnailFile());
								auxImage.setPosX(loc.getThumbnailPosition()
										.getPosX());
								auxImage.setPosY(loc.getThumbnailPosition()
										.getPosY());
								auxImage.setHeight(loc.getThumbnailPosition()
										.getHeight());
								auxImage.setWidth(loc.getThumbnailPosition()
										.getWidth());
								auxImage.setId(loc.getDeviceIDRef());
								thumbnails.add(auxImage);
							} catch (Exception e) {
							}

						}

					}
				}
			}
			s.setDeviceThumbnails(thumbnails);
		}

	}

	public void onClick(ActionEvent event) {
		String currentItem = (String) event.getComponent().getAttributes().get(
				"selectedLocation");
		getImages(currentItem);
	}

	public Collection<SubLocation> getSubLocations() {
		return subLocations;
	}

	public void setSubLocations(Collection<SubLocation> subLocations) {
		this.subLocations = subLocations;
	}

	public Collection<Image> getLocationDevices() {
		return locationDevices;
	}

	public void setLocationDevices(Collection<Image> locationDevices) {
		this.locationDevices = locationDevices;
	}

	public Boolean getPageRendered() {
		return pageRendered;
	}

	public void setPageRendered(Boolean pageRendered) {
		this.pageRendered = pageRendered;
	}

	public Location getCurrentLocation() {
		return currentLocation;
	}

	public void setCurrentLocation(Location currentLocation) {
		this.currentLocation = currentLocation;
	}

}
