/*
 * Copyright (C) 2010 Xisco Faulí Tarazona
 *
 * This file is part of Domestica.
 * 
 * Domestica is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * Domestica is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domestica; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
*/

package objects;

import java.util.Collection;
import java.util.Map;




public class Device {

	private String id;
	private String tunnel;
	private String type;
	private String profile;
	private String address;
	private String dataType;
	private Map properties;
	private Collection StateImageList;
	private String platformName;	
	

	public Device(String id, String tunnel, String type,
			String profile, String address, String dataType,String platformName, Collection StateImageList,Map properties) {
		this.id = id;
		this.tunnel = tunnel;
		this.type = type;
		this.profile = profile;
		this.address = address;
		this.StateImageList = StateImageList;
		this.dataType = dataType;
		this.platformName = platformName;
		this.properties = properties;
	}



	public Collection getStateImageList() {
		return StateImageList;
	}



	public void setStateImageList(Collection stateImageList) {
		StateImageList = stateImageList;
	}

	public String getPlatformName() {
		return platformName;
	}



	public void setPlatformName(String platformName) {
		this.platformName = platformName;
	}



	public Map getProperties() {
		return properties;
	}



	public void setProperties(Map properties) {
		this.properties = properties;
	}


	public String getId() {
		return id;
	}



	public void setId(String id) {
		this.id = id;
	}



	public String getTunnel() {
		return tunnel;
	}



	public void setTunnel(String tunnel) {
		this.tunnel = tunnel;
	}



	public String getType() {
		return type;
	}



	public void setType(String type) {
		this.type = type;
	}



	public String getProfile() {
		return profile;
	}



	public void setProfile(String profile) {
		this.profile = profile;
	}



	public String getAddress() {
		return address;
	}



	public void setAddress(String address) {
		this.address = address;
	}



	public String getDataType() {
		return dataType;
	}



	public void setDataType(String dataType) {
		this.dataType = dataType;
	}


}
