/*
 * Copyright (C) 2010 Xisco Faulí Tarazona
 *
 * This file is part of Domestica.
 * 
 * Domestica is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * Domestica is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domestica; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
*/

package objects;

import java.io.Serializable;
import java.util.Collection;

public class Location implements Serializable {
	private String id;
	private String name;
	private String superLocation;
	private Image image;
	private Collection<SubLocation> subLocation;
	private Collection<StateImage> locationDevice;



	public Location(String id, String name, String superLocation, Image image,
			Collection subLocation, Collection locationDevice) {
		this.id = id;
		this.name = name;
		this.superLocation = superLocation;
		this.image = image;
		this.subLocation = subLocation;
		this.locationDevice = locationDevice;
	}


	public String getId() {
		return id;
	}


	public void setId(String id) {
		this.id = id;
	}


	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}


	public String getSuperLocation() {
		return superLocation;
	}


	public void setSuperLocation(String superLocation) {
		this.superLocation = superLocation;
	}


	public Image getImage() {
		return image;
	}


	public void setImage(Image image) {
		this.image = image;
	}


	public Collection<SubLocation> getSubLocation() {
		return subLocation;
	}


	public void setSubLocation(Collection<SubLocation> subLocation) {
		this.subLocation = subLocation;
	}


	public Collection<StateImage> getLocationDevice() {
		return locationDevice;
	}


	public void setLocationDevice(Collection<StateImage> locationDevice) {
		this.locationDevice = locationDevice;
	}

}

